<?php
 /**************************************************************************\
 * eGroupWare - correspondence - email UI Class for Attaching Files         *
 * http://www.egroupware.org                                                *
 *                                                                          *
 * File adapted directly from eGroupWare file email/attach_file.php	    *
 * Copyright 2002 Angles Puglisi					    *
 * --------------------------------------------				    *
 *  This program is free software; you can redistribute it and/or modify it *
 *  under the terms of the GNU General Public License as published by the   *
 *  Free Software Foundation; either version 2 of the License, or (at your  *
 *  option) any later version.						    *
 \**************************************************************************/

class uiattach
{
  var $uploaddir;
  var $file_data = array();
  var $control = array();
  var $config;

  var $allowed_exts;

  var $public_functions = array(
				'attach'	=> True
				);
  
  function uiattach()
  {
    $this->allowed_exts = array ('pdf');

    $this->config = CreateObject('phpgwapi.config','correspondence');
    $this->config->read_repository();
  }

  function fill_control_data()
  {
    $this->control['action'] = htmlentities($_POST['action']);
    $this->control['delete'] = $_POST['delete'];
  }

  function fill_file_data()
  {
    $this->file_data['tmp_name'] = stripslashes(trim($_FILES['uploadedfile']['tmp_name']));
    $this->file_data['name'] = stripslashes(trim($_FILES['uploadedfile']['name']));
    $this->file_data['size'] = stripslashes(trim($_FILES['uploadedfile']['size']));
    $this->file_data['type'] = stripslashes(trim($_FILES['uploadedfile']['type']));
    
    // sometimes PHP is very clue-less about MIME types, and
    // gives NO file_type. RFC default for unknown MIME type is:
    $mime_type_default = 'application/octet-stream';

    // so if PHP did not pass any file_type info, then substitute
    // the rfc default value
    if (trim($this->file_data['type']) == '') {
      $this->file_data['type'] = $mime_type_default;
    }
    
    // Netscape 6 passes file_name with a full path, we need
    // to extract just the filename
    $this->file_data['name'] = $this->wbasename($this->file_data['name']);
  }

  function wbasename($input)
  {
    if (strstr($input, SEP) == False) {
      // no filesystem seperator is present
      return $input;
    }
    
    for($i=0; $i < strlen($input); $i++ ) {
      $pos = strpos($input, SEP, $i);
      if ($pos != false) {
	$lastpos = $pos;
      }
    }
    return substr($input, $lastpos + 1, strlen($input));
  }
  
  function attach()
  {
    $doc_id = $_GET['doc_id']?intval($_GET['doc_id']):0;
    $tmp_doc_id = $_GET['tmp_doc_id']?intval($_GET['tmp_doc_id']):0;

    $egw_flags = Array(
			 'currentapp' => 'correspondence',
			 'enable_network_class' => True,
			 'nonavbar'   => True
			 );
    
    $GLOBALS['egw_info']['flags'] = $egw_flags;

    $GLOBALS['egw_info']['flags']['java_script'] = "\n"
      . '<script type="text/javascript" src="'
      . $GLOBALS['egw']->link('/correspondence/js/attach.js')
      ."\">\n</script>\n";

    $GLOBALS['egw']->common->egw_header();

    $tpl = CreateObject('phpgwapi.Template',EGW_APP_TPL);    
    $tpl->set_file(
		   Array(
			 't_attach' => 'attach.tpl',
			 't_attach_blocks' => 'attach_blocks.tpl'
			 )
		   );
    $tpl->set_block('t_attach_blocks','B_alert_msg','V_alert_msg');
    $tpl->set_block('t_attach_blocks','B_attached_list','V_attached_list');
    $tpl->set_block('t_attach_blocks','B_attached_none','V_attached_none');
    $tpl->set_block('t_attach_blocks','B_delete_btn','V_delete_btn');


    // initialize some variables
    $alert_msg = '';
    $totalfiles = 0;
    
    // FIX: this code should be moved to another place; it needs to
    // run just once in a while
    $basedir = $GLOBALS['egw_info']['server']['files_dir'].SEP.'correspondence';
    if (!is_dir($basedir)) {
      mkdir($basedir,0700);
    }

    if ($doc_id > 0) {
      $this->uploaddir = $GLOBALS['egw_info']['server']['files_dir'].SEP.'correspondence'.SEP.$doc_id;
    } elseif ($tmp_doc_id > 0) {
      $this->uploaddir = $GLOBALS['egw_info']['server']['files_dir'].SEP.'correspondence'.SEP.'T'.$tmp_doc_id;
    } else {
      return False;
    }
    if (!is_dir($this->uploaddir)) {
      mkdir($this->uploaddir,0700);
    }
                        
    // if we were NOT able to create this directory, then
    // make an ERROR report
    if (!is_dir($this->uploaddir)) {
      $alert_msg .= 'Error:'.'<br />'
	. lang('Server is unable to access Correspondence upload directory').'<br />'
	. $this->uploaddir.'<br />'
	. lang('Please check your configuration').'<br />'
	. '<br />';
    }
    
    // grab externally provided information
    $this->fill_control_data();
    $this->fill_file_data();

    if ($this->control['action'] == lang('Delete') || $this->control['action'] == htmlentities(lang('Delete'))) {
      for ($i=0; $i<count($this->control['delete']); $i++)	{
	$full_fname_attachment = $this->uploaddir.SEP.$this->control['delete'][$i];
	$full_fname_metafile = $this->uploaddir.SEP.$this->control['delete'][$i] . '.info';
	if (file_exists($full_fname_attachment)) {
	  unlink($full_fname_attachment);
	}
	
	// and the associated ".info" metafile
	if (file_exists($full_fname_metafile)) {
	  unlink($full_fname_metafile);
	}
      }
    }
    
    if (($this->control['action'] == lang('Attach File') || $this->control['action'] == htmlentities(lang('Attach File'))) && ($this->file_data['tmp_name'] != '') && ($this->file_data['tmp_name'] != 'none')) {

      $a = explode('.',$this->file_data['name']);
      end($a);
      $file_ext = strtolower(pos($a));

      if($this->config->config_data['pdf_only'] == 'True' && !in_array($file_ext,$this->allowed_exts)) {
	$alert_msg = lang('input error:').'<br />'
	  . lang('only acrobat pdf files are allowed').'<br />'
	  . '<br />';
      }
      else {
	srand((double)microtime()*1000000);
	$random_number = rand(100000000,999999999);
	$newfilename = md5($this->file_data['tmp_name']
			   . ', '.$this->file_data['name']
			   . ', '.$GLOBALS['egw_info']['user']['sessionid']
			   . time().$_SERVER['REMOTE_ADDR'].$random_number);
	
	// Check for uploaded file of 0-length, or no file
	// (patch from Zone added by Milosch)
	if ($this->file_data['size'] == 0) {
	  touch ($this->uploaddir.SEP.$newfilename);
	}
	else {
	  move_uploaded_file($this->file_data['tmp_name'],
			     $this->uploaddir.SEP.$newfilename);
	}
	
	$ftp = fopen($this->uploaddir.SEP.$newfilename . '.info','wb');
	fputs($ftp,$this->file_data['type']."\n".$this->file_data['name']."\n");
	fclose($ftp);
      }
    }
    elseif (($this->control['action'] == lang('Attach File')) && (($this->file_data['tmp_name'] == '') || ($this->file_data['tmp_name'] == 'none'))) {
      $langed_attach_file = lang("Attach File");
      $alert_msg = lang('input error:').'<br />'
	. lang('Please submit a filename to attach').'<br />'
	. lang('You must click %1 for the file to actually upload',
	       '"'.lang('Attach File').'"').'.<br />'
	. '<br />';
    }
    $dh = opendir($this->uploaddir);

    while (false !== ($file = readdir($dh))) {
      if (($file != '.') && ($file != '..') && (ereg("\.info",$file))) {
	$file_info = file($this->uploaddir.SEP.$file);
	
	// get filesize in kb, but do not tell user a file is 0kb,
	// because it is probably closer to 1kb
	// actual 0kb files are probably an error, and are detected
	// in the actual upload code (HOPEFULLY) 
	$real_file = str_replace('.info','',$file);
	$real_file_size = ((int) (@filesize($this->uploaddir.SEP.$real_file)/1024));
	if ($real_file_size < 1) {
	  $real_file_size = 1;
	}
	
	// for every file, fill the file list template with it
	$tpl->set_var('ckbox_delete_name','delete[]');
	$tpl->set_var('ckbox_delete_value',substr($file,0,-5));
	$tpl->set_var('hidden_delete_name',substr($file,0,-5));
	$tpl->set_var('hidden_delete_filename', $file_info[1]);
	$tpl->set_var('ckbox_delete_filename', 
		      $file_info[1].' ('.$real_file_size.'k)');
	$tpl->parse('V_attached_list','B_attached_list', True);
	$totalfiles++;
      }
    }  
    
    closedir($dh);
    if ($totalfiles == 0) {
      // there is no list of files, clear that block
      $tpl->set_var('V_attached_list','');
      // there is no delete button because there are no
      // files to delete, clear that block
      $tpl->set_var('V_delete_btn','');
      // show the none block
      $tpl->set_var('text_none',lang('None'));
      $tpl->parse('V_attached_none','B_attached_none');
    }
    else {
      // we have files, clear the "no files" block
      $tpl->set_var('V_attached_none','');
      // fill the delete submit form
      $tpl->set_var('btn_delete_name','action');
      $tpl->set_var('btn_delete_value',lang('Delete'));
      $tpl->parse('V_delete_btn','B_delete_btn');
    }
    
    $body_tags = 'bgcolor="'.$GLOBALS['egw_info']['theme']['bg_color'].'" alink="'.$GLOBALS['egw_info']['theme']['alink'].'" link="'.$GLOBALS['egw_info']['theme']['link'].'" vlink="'.$GLOBALS['egw_info']['theme']['vlink'].'"';
    if (!$GLOBALS['egw_info']['server']['htmlcompliant']) {
      $body_tags .= ' topmargin="0" marginheight="0" marginwidth="0" leftmargin="0"';
    }
    
    // where to submit the form to
    if ($doc_id > 0) {
      $form_action = $GLOBALS['egw']->link('/index.php',
		     array(
			 'menuaction' => 'correspondence.uiattach.attach',
			 'doc_id' => $doc_id
			 ));
    } else {
      $form_action = $GLOBALS['egw']->link('/index.php',
		     array(
			 'menuaction' => 'correspondence.uiattach.attach',
			 'tmp_doc_id' => $tmp_doc_id
			 ));
    }

    $update_url = $GLOBALS['egw']->link('/index.php',array('menuaction' => 'correspondence.bocorrespondence.update_attachments','doc_id' => $doc_id));

    $charset = lang('charset');
    $tpl->set_var('charset',$charset);
    $tpl->set_var('page_title',$GLOBALS['egw_flags']['currentapp'] . ' - ' .lang('File attachment'));
    $tpl->set_var('font_family',$GLOBALS['egw_info']['theme']['font']);
    $tpl->set_var('body_tags',$body_tags);
    if ($alert_msg != '') {
      $tpl->set_var('alert_msg',$alert_msg);
      $tpl->parse('V_alert_msg','B_alert_msg');
    }
    else {
      $tpl->set_var('V_alert_msg','');
    }
    $tpl->set_var('form_method','POST');
    $tpl->set_var('form_action',$form_action);
    $tpl->set_var('text_attachfile',lang('Attach file'));
    $tpl->set_var('text_currattached',lang('Current attachments (%1)',$totalfiles));
    $tpl->set_var('txtbox_upload_desc',lang('File'));
    $tpl->set_var('txtbox_upload_name','uploadedfile');
    $tpl->set_var('btn_attach_name','action');
    $tpl->set_var('btn_attach_value',lang('Attach File'));
    $tpl->set_var('btn_done_name','done');
    $tpl->set_var('btn_done_value',lang('Done'));
    $tpl->set_var('btn_done_js','copyback(\''.$update_url.'\')');

    $tpl->pfp('out','t_attach');
  }
}
?>
